# version 2022.1
$username = 'administrator'
$securePW = Read-Host -AsSecureString -Prompt "Enter password for Men&Mice 'administrator'"

$password =[Runtime.InteropServices.Marshal]::PtrToStringAuto([Runtime.InteropServices.Marshal]::SecureStringToBSTR($securePW))

$ErrorActionPreference = 'Stop'
cd $PSScriptRoot
. ./utils.ps1 -logToConsole
$api = [mm]::getAPI($username, $password)


# Requests
# - Modify: Group, make optional
# - Add: Workflow, mandatory, readOnly, free-text (since it's read-only)
# - Ebay may cleanup other properties at will, such as Application
log 'Making Request.Group optional'
$api.call('ModifyPropertyDefinition', @{
    objType = 'ChangeRequest'
    property = 'Group'
    propertyDefinition = @{
        name="Group"
        type="String"
        mandatory=$false
    }
})

log "Adding Request.Workflow"
$api.call('AddPropertyDefinition', @{
    objType = 'ChangeRequest'
    propertyDefinition = @{
        name="Workflow"
        type="String"
        mandatory=$true
        readOnly=$true
    }
})


# Zones, add
# - "Workflow", String with list items: Peer Approval, Pre-Defined Approval
# - "Approval Group", String
# - "Record expiry time", number
log "Adding Zone.Workflow"
$api.call('AddPropertyDefinition', @{
    objType = 'DNSZone'
    propertyDefinition = @{
        name="Workflow"
        type="String"
        listItems = @("Peer Approval", "Pre-Defined Approval")
    }
})

log "Adding Zone.Approval Group"
$api.call('AddPropertyDefinition', @{
    objType = 'DNSZone'
    propertyDefinition = @{
        name="Approval Group"
        type="String"
    }
})

log 'Adding Zone.Record expiry time'
$api.call('AddPropertyDefinition', @{
    objType = 'DNSZone'
    propertyDefinition = @{
        name="Record expiry time"
        type="Integer"
    }
})

# Records
# - Add "State" with items: OK, Expiring*, Expiring**, Expiring***, Expired*, Expired
# - Add "Manager", readOnly free text
# - Modify: rename Group to TeamDL
log 'Adding Record.State'
$api.call('AddPropertyDefinition', @{
    objType = 'DNSRecord'
    propertyDefinition = @{
        name="State"
        type="String"
        listItems = @('OK','Expiring*','Expiring**','Expiring***','Expired*','Expired')
    }
})

log 'Adding Record.Manager'
$api.call('AddPropertyDefinition', @{
    objType = 'DNSRecord'
    propertyDefinition = @{
        name="Manager"
        type="String"
        readOnly=$true
    }
})

log 'Renaming Group to TeamDL (on Requests)'
$api.call('ModifyPropertyDefinition', @{
    objType = 'DNSRecord'
    property="Group"
    propertyDefinition = @{
        name="TeamDL"
        type="String"
        readOnly=$true
    }
})